---
title: RTCDataChannel.close()
slug: Web/API/RTCDataChannel/close
tags:
  - API
  - Communication
  - Data Transfer
  - Method
  - Networking
  - RTCDataChannel
  - Reference
  - WebRTC
  - WebRTC API
  - close
---
<p>{{APIRef("WebRTC")}}</p>

<p>The <code><strong>RTCDataChannel.close()</strong></code> method closes the {{domxref("RTCDataChannel")}}. Either peer is permitted to call this method to initiate closure of the channel.</p>

<p>Closure of the data channel is not instantaneous. Most of the process of closing the connection is handled asynchronously; you can detect when the channel has finished closing by watching for a {{event("close")}} event on the data channel.</p>

<p>The sequence of events which occurs in response to this method being called:</p>

<ol>
 <li>{{domxref("RTCDataChannel.readyState")}} is set to <code>"closing"</code>.</li>
 <li>A background task is established to handle the remainder of the steps below, and <code>close()</code> returns to the caller.</li>
 <li>The transport layer deals with any buffered messages; the protocol layer decides whether to send them or discard them.</li>
 <li>The underlying data transport is closed.</li>
 <li>The {{domxref("RTCDataChannel.readyState")}} property is set to <code>"closed"</code>.</li>
 <li>If the transport was closed with an error, the <code>RTCDataChannel</code> is sent a {{event("NetworkError")}} event.</li>
 <li>A {{domxref("close")}} event is sent to the channel.</li>
</ol>

<div class="note">
<p>In Firefox, the {{domxref("RTCDataChannel")}} interface was implemented under the name <code>DataChannel</code> until Firefox 24, so this method was called <code>DataChannel.close()</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCDataChannel</em>.close();
</pre>

<h2 id="Parameters">Parameters</h2>

<p>None.</p>

<h2 id="Return_value">Return value</h2>

<p><code>undefined</code>.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var pc = new RTCPeerConnection();
var dc = pc.createDataChannel("my channel");

dc.onmessage = function (event) {
  console.log("received: " + event.data);
  dc.close(); // We decided to close after the first received message
};

dc.onopen = function () {
  console.log("datachannel open");
};

dc.onclose = function (
  console.log("datachannel close");
};

// Now negotiate the connection and so forth...
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcdatachannel-close', 'RTCDataChannel.close()') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel.close")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
 <li>{{domxref("RTCDataChannel")}}</li>
 <li>{{domxref("RTCDataChannel.readyState")}}</li>
 <li>{{event("close")}} event</li>
</ul>
